package org.honours.actions;

import java.awt.Color;

import org.expeditee.actions.Actions;
import org.expeditee.actions.Misc;
import org.expeditee.gui.DisplayIO;
import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameIO;
import org.expeditee.gui.FrameKeyboardActions;
import org.expeditee.gui.MessageBay;
import org.expeditee.items.Text;
import org.honours.Main;
import org.honours.collection.Collection;
import org.honours.collection.CollectionItem;
import org.honours.collection.NoteLayer;
import org.honours.gui.HonoursFrameIO;
import org.honours.gui.Interfaces;

public class MiscActions {

	/**
	 * Copy items on a frame which
	 * can be pasted on another frame.
	 */
	public static void CopyFrame(){
		HonoursFrameIO.CopyFrame();
	}
	
	/**
	 * Paste a copied frame on to
	 * the current frame being displayed.
	 */
	public static void PasteFrame(){
		HonoursFrameIO.PasteFrame();
	}
	
	/**
	 * Toggle toolbar on and off.
	 */
	public static void ToggleToolbar(){
		
		HonoursFrameIO.ToggleToolbar();
	}
	
	/**
	 * Toggle display of toggle toolbar on and off.
	 */
	public static void ToggleToggler(){
		HonoursFrameIO.toggleToggler();
	}
	
	/**
	 * Toggle display of layers on and off.
	 */
/*	public static void ToggleDisplayLayers(){
		HonoursFrameIO.ToggleLayersDisplay();
		
		if(HonoursFrameIO.DISPLAY_LAYERS)
			MessageBay.displayMessage("Display of layers on");
		else
			MessageBay.displayMessage("Display of layers off");
	}*/
	
	
	///////////
	
	public static void AddNewNote(){
		
		AddNewNote(DisplayIO.getCurrentFrame());
		Actions.PerformActionCatchErrors(DisplayIO.getCurrentFrame(), null, "Format");
	}
	
	public static void AddNewNote(Frame frame){
		Collection collect = Collection.findCollection(frame);

		if(collect != null){
			CollectionItem cItem = CollectionItem.findCollectionItem(frame, collect);
			if(cItem != null)
				AddNewNote(cItem,collect);
		}
	}
	
	/**
	 * Add a new note about a collection item which will be displayed
	 * on the item's frame.
	 * @param collectItem
	 * @param collect
	 */
	public static void AddNewNote(CollectionItem collectItem, Collection collect){

		NoteLayer noteLayer = null;
		
		//Check if collectionItem has a notelayer.
		if(collectItem.getNoteLayer() != null){
			noteLayer = collectItem.getNoteLayer();
			
		}else{
			//Create a new note layer.
			noteLayer = new NoteLayer();
			noteLayer.setAssociatedItem(collectItem);
			
			//Create a new frame and set noteLayer's frame attribute.
			int frameNumber = FrameIO.getLastNumber("notesmain") + 1;
			HonoursFrameIO.generateFrame(frameNumber, "notesmain");
			Frame layerFrame = FrameIO.LoadFrame("notesmain"+frameNumber);
			noteLayer.setFrame(layerFrame);
			noteLayer.setAssociatedItem(collectItem);
			
			collectItem.setNoteLayer(noteLayer);
			
			//now put collectItem back in collection list.
			int itemIndex = CollectionItem.getPositionInCollection(collectItem, collect);
			collect.getItems().remove(itemIndex);
			collect.getItems().add(itemIndex, collectItem);
			
			//put collection back in collection list.
			int collectIndex = Collection.getCollectionPosition(collect);
			Main._collections.remove(collectIndex);
			Main._collections.add(collectIndex,collect);
		}
		
		//debugging
		//System.err.println("*** link (in AddNewNote): " + noteLayer.getFrame().getName());
		
		//Add new text item to noteLayer's frame in a free space - for now
		//just add at position (200,200) and hope that any other note has been moved since.
		Text noteText = noteLayer.getFrame().addText(200, 200, "@[Insert note here]", null);
		noteText.setBackgroundColor(Color.LIGHT_GRAY);
		noteText.setColor(Color.BLACK);
		noteText.setBorderColor(Color.BLACK);
		noteText.setThickness(1);
		noteLayer.getFrame().setSaved();
		FrameKeyboardActions.Refresh();
		
		HonoursFrameIO.DISPLAY_NOTES = false;
		Text displayText = (Text)Misc.getItemContainingData("OptionViewNotes",FrameIO.LoadFrame(Interfaces.NAVIGATION_OVERLAY_VIEW_NOTES_CLICKABLE));
		displayText.setText("Hide Notes");
		
		Text overlayLink = (Text)Misc.getItemContainingData(Interfaces.OVERLAY_TOOLBAR_DATA, DisplayIO.getCurrentFrame());
		
		if(!overlayLink.getLink().equals(Interfaces.NAVIGATION_OVERLAY_VIEW_NOTES_CLICKABLE))
			overlayLink.setLink(Interfaces.NAVIGATION_OVERLAY_VIEW_NOTES_CLICKABLE);
		
		HonoursFrameIO.ToggleNotesDisplay(collectItem);
	}
	
	
	public static void ToggleNotesView(){
		ToggleNotesView(DisplayIO.getCurrentFrame());
	}
	
	
	/**
	 * Toggle the display of notes for a collection item on and off.
	 * @param frame
	 */
	public static void ToggleNotesView(Frame frame){
		Collection collect = Collection.findCollection(frame);
		if(collect != null){
			CollectionItem cItem = CollectionItem.findCollectionItem(frame, collect);
			if(cItem != null)
				HonoursFrameIO.ToggleNotesDisplay(cItem);
		}
	}

	
}
